MODULE generic

  INTERFACE func
     MODULE PROCEDURE func_integer
     MODULE PROCEDURE func_real
  END INTERFACE

CONTAINS

  SUBROUTINE func_integer(value)
    IMPLICIT NONE
    INTEGER, INTENT(OUT) :: value
   
    value = 5
  END SUBROUTINE func_integer

  SUBROUTINE func_real(value)
    IMPLICIT NONE
    REAL, INTENT(OUT) :: value

    value = 2.0
  END SUBROUTINE func_real

END MODULE generic


MODULE parametric

  INTERFACE action
     MODULE PROCEDURE action_integer
     MODULE PROCEDURE action_real
  END INTERFACE

CONTAINS 
  
  SUBROUTINE action_integer (func, result)
    IMPLICIT NONE

    INTERFACE
       SUBROUTINE func(value)
         IMPLICIT NONE
         INTEGER, INTENT(OUT) :: value
       END SUBROUTINE func
    END INTERFACE
    INTEGER, INTENT(OUT) :: result

    CALL func(result)
  END SUBROUTINE action_integer
  
  SUBROUTINE action_real (func, result)
    IMPLICIT NONE

    INTERFACE 
       SUBROUTINE func(value)
         IMPLICIT NONE
         REAL, INTENT(OUT) :: value
       END SUBROUTINE func
    END INTERFACE
    REAL, INTENT(OUT) :: result

    CALL func(result)
  END SUBROUTINE action_real

END MODULE parametric

PROGRAM mix_it
USE generic
USE parametric

  INTEGER :: an_integer
  REAL    :: a_real

  ! Working but inelegant
  CALL action(func_integer, an_integer)
  print *, 'should be 5:', an_integer
  ! Wished way, illegal
  CALL action(func, an_integer)
  print *, 'should be 5:', an_integer

END PROGRAM mix_it

